function Ped07001_ControleVisitasVendedor_Controller(Ped07001_ControleVisitasVendedor_Service, ZHPromise, localStorageEngine, Ped00100_lancamentoPedido_Controller, Ped00100_lancamentoPedido_Service, templateManager, ScreenService, General, ZhFilterPreferences) {

    this.operador               = [];
    this.vendedor               = [];
    this.filialLogada           = [];
    this.email                  = [];
    this.dadosFilial            = [];
    this.nrorg                  = [];
    this.parametros             = [];
    this.dataAgevenrealizado    = [];
    this.dataPedidos            = [];
    this.valida                 = true;

    this.openFilter = function(widget){
        ZhFilterPreferences.setOriginalFilter(widget.id);
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
    var mensagens =  {
        operadorNaoVinculado: 'Operador não Vinculado a um Vendedor.',
        operadorVinculadoVen: 'Operador Vinculado a mais de um Vendedor.',
        errorEnviarDados: 'Erro ao enviar dados. Tente novamente mais tarde!',
        dadosEnviados: 'Dados enviados com sucesso!'
    };

   this.save = function(widget) {
       if (widget.currentRow.DSJUSTIFICA !== 0) {
            if (widget.currentRow.DSREALIZADO){
                widget.currentRow.DSJUSTIFICA = 2;
            } else {
                widget.currentRow.DSJUSTIFICA = 1;
            }
        }
        var CDPRIMARY = widget.currentRow.CDPRIMARY.split("-");
        widget.currentRow.CDREGIAOPED = CDPRIMARY[0];
        widget.currentRow.CDVENDEDOR = CDPRIMARY[1].split("/")[0].replace(" ","");
        widget.currentRow.CDCLIENTE = CDPRIMARY[1].split("/")[1];
        widget.currentRow.DTREALIZADO = widget.currentRow.DTAGEVENDREGIAO;
        widget.paramsNewCode.__new_code_pk = 'AGEVENREALIZADO'+General.getFieldValue('CDVENDEDOR', 'DIARIO')+General.getFieldValue('DTAGEVENDREGIAO', 'DIARIO');
        if (widget.currentRow.NRSEQREALIZADO) {
            widget.currentRow.__is_new = false;
        } else {
            widget.currentRow.__is_new = true;
        }
        General.saveCrud(widget).then(function(){
            templateManager.container.getWidget("DIARIOTABBED").activate();
            if (widget.currentRow.__is_new === true) {
                widget.currentRow.__is_new = false;
            }
            templateManager.container.refresh();
            templateManager.container.getWidget('DIARIO').redraw();
        });
    };

    this.getCodigoVendedor = function() {
        return this.vendedor.CDVENDEDOR;
    };

    this.getCDCLIENTE = function() {
        var widget = templateManager.container.getWidget('DIARIO');
        var CDPRIMARY = widget.currentRow.CDPRIMARY.split("-");
        var CDCLIENTE = CDPRIMARY[1].split("/")[1];
        return CDCLIENTE;
    };

    this.getDTHRLANPED = function() {
        var widget = templateManager.container.getWidget('DIARIO');
        var DTAGEVENDREGIAO = widget.currentRow.DTAGEVENDREGIAO.split(" ");
        return DTAGEVENDREGIAO[0]+'%';
    };

    this.abreSwipe = function(args) {
        if(args.row.CDPARENT) {
            var tabbedWidget = templateManager.container.getWidget('DIARIOTABBED');
            tabbedWidget.widgets[0].currentRow = templateManager.container.getWidget('DIARIO').currentRow;
            ScreenService.openSwipe(templateManager.container.getWidget('DIARIOTABBED'));
            templateManager.container.getWidget('DIARIOFORM').view();
        }
    };

    this.closeSwipe = function() {
        templateManager.container.getWidget('DIARIO').activate();
        ScreenService.closeSwipe(templateManager.container.getWidget('DIARIO'));
    };

    this.enablePedidos = function(boolean) {
        templateManager.container.getWidget('PEDIDO').enabled = boolean;
        // if (templateManager.container.getWidget('DIARIOFORM').currentRow.DSREALIZADO ){

        // }
    };

    // --------------------------------DEKTOP e MOBILE-------------------------------------------//

    // --------------------------------------DEKTOP----------------------------------------------//

    this.setFilters = function () {
        var widgetData = templateManager.container.getWidget('PEDIDO');
        widgetData.dataSourceFilter[1].value = '@Ped07001_ControleVisitasVendedor_Controller.getCDCLIENTE()@';
        widgetData.dataSourceFilter[2].value = '@Ped07001_ControleVisitasVendedor_Controller.getDTHRLANPED()@';
    };

    this.setFiltersMobile = function () {
        Ped07001_ControleVisitasVendedor_Service.getData('ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree');
    };

    // --------------------------------------DEKTOP------------------------------------------------//


    // ---------------------------------------MOBILE------------------------------------------------//

	this.retornaOperadorLogado = function(){
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];
        return localStorageEngine.download("ped#/crud/operador", filter);
	};

    this.verifyOperator = function (container, args) {
        if (this.valida) {
            args.e.preventDefault();
            this.retornaOperadorLogado().then(function (callback) {
                this.operador = callback[0].CDOPERADOR;
                this.email = callback[0].DSEMAILOPER;
                var filter = [
                    {
                        "name": "CDOPERADOR",
                        "operator": "=",
                        "value": this.operador
                    }
                ];
                return Ped00100_lancamentoPedido_Service.filtraVendedor(filter);
            }.bind(this))
            .then(function(callback){
                if(callback.dataset.vendedor.length && callback.dataset.vendedor.length <= 1){
                    this.vendedor = callback.dataset.vendedor[0];
                    return Ped00100_lancamentoPedido_Service.getLocalVar('CDFILIAL');
                } else if(!callback.dataset.vendedor.length){
                    //ScreenService.showCustomDialog(mensagens.operadorNaoVinculado, 'exclamation', 'exclamation', [{
                    ScreenService.showCustomDialog("Operador não Vinculado a um Vendedor.", 'exclamation', 'exclamation', [{    
                        label: ScreenService.i18n("OK"),
                        code: function(){openWindow('product#dashboard');}
                    }]);
                    return ZHPromise.defer().reject(1);
                } else {
                    //ScreenService.showCustomDialog(mensagens.operadorVinculadoVen, 'exclamation', 'exclamation', [{
                    ScreenService.showCustomDialog("Operador Vinculado a mais de um Vendedor.", 'exclamation', "exclamation", [{
                        label: ScreenService.i18n("OK"),
                        code: function(){openWindow('product#dashboard');}
                    }]);
                    return ZHPromise.defer().reject(2);
                }
            }.bind(this))
            .then(function(callback){
                this.filialLogada = callback;
                var filter = [
                    {
                        "name": "CDOPERADOR",
                        "operator": "=",
                        "value": this.operador
                    }
                ];
                return Ped00100_lancamentoPedido_Service.filtraFilioper(filter);
            }.bind(this))
            .then(function(callback){
                this.dadosFilial = callback.dataset.filioper;
                var filial = [];
                if (this.dadosFilial.length > 1) {
                    for (var i = 0; i < this.dadosFilial.length; i++) {
                        filial.push(this.dadosFilial[i].CDFILIAL);
                    }
                } else {
                    filial = this.dadosFilial[0].CDFILIAL;
                }
                var filter = [
                    {
                        "name": "CDFILIAL",
                        "operator": "IN",
                        "value": filial
                    }
                ];
                var filterP = [
                    {
                        "name": "CDFILIAL",
                        "operator": "IN",
                        "value": filial
                    }
                ];
                var promises = [];
                promises.push(Ped00100_lancamentoPedido_Service.retornaDadosUnidade(filter));
                promises.push(Ped00100_lancamentoPedido_Service.findParameters(filterP));
                return ZHPromise.all(promises);
            }.bind(this))
            .then(function(callback){
                if(this.dadosFilial.length > 0){
                    openWindow('ped_pedidos#ped07001_controle_visitas_vendedor');
                    this.dadosFilial = callback[0].dataset.filial_empresa_endefili;
                    this.parametros = callback[1].dataset.parampedido;
                    this.valida = false;
                } else {
                    ScreenService.showCustomDialog('Operador não Vinculado a uma Filial', 'exclamation', 'exclamation', [{
                        label: ScreenService.i18n("OK"),
                        code: function(){openWindow('product#dashboard');}
                    }]);
                }
            }.bind(this));
        } else {
            this.valida = true;
        }
    };

    this.sincroniza = function() {
        var filter = [
            {
                "name": "CDVENDEDOR",
                "operator": "=",
                "value": this.vendedor.CDVENDEDOR
            },
            {
                "name": "DTAGEVENDREGIAO",
                "operator": ">=",
                "value": this.getDataSincroniza()
            }
        ];

        Ped07001_ControleVisitasVendedor_Service.getAgeVenRealizado(filter).then(function(success) {
            var filter = [
                {
                    "name": "CDVENDEDOR",
                    "operator": "=",
                    "value": this.vendedor.CDVENDEDOR
                },
                {
                    "name": "DTHRLANPED",
                    "operator": ">=",
                    "value": this.getDataSincroniza()
                }
            ];
            this.dataAgevenrealizado = success.dataset.agevenrealizado_agendavendedor_regiaoped;
            Ped07001_ControleVisitasVendedor_Service.setData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree", this.dataAgevenrealizado);
            Ped07001_ControleVisitasVendedor_Service.findPedidos(filter).then(function(success){
                this.dataPedidos = success.dataset.pedido_filial_modpgto;
                Ped07001_ControleVisitasVendedor_Service.setData("ped_pedidos#/pedido_filial_modpgto",   this.dataPedidos);
                ScreenService.showMessage("Sincronização Completa com Sucesso.");
                this.getDataSource();
                var widgetFiltro = templateManager.container.getWidget('DIARIO');
                this.filtroRegiao(widgetFiltro);
                ScreenService.closePopup();
            }.bind(this));
        }.bind(this))
        .catch(function(){
            ScreenService.showMessage("Verifique sua Conexão.");
        }.bind(this));
    };

    this.getDataSource = function() {
       Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree").then(function (success) {
            this.dataAgevenrealizado = success;
            if (this.dataAgevenrealizado.length > 0) {
                Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/pedido_filial_modpgto").then(function (success) {
                    this.pedidos  = success;
                }.bind(this), function (error) {
                    ScreenService.showMessage(error);
             });
            }
        }.bind(this));
    };

    this.filtroRegiao = function(widget) {
        var compromissos = [];
        compromissos = this.dataAgevenrealizado.filter(function(value){return value.DTAGEVENDREGIAO == moment().format('DD/MM/YYYY') + ' 00:00:00';}.bind(this));
        widget.dataSource.data = compromissos;
        if (templateManager.container) {
            var widgetForm = templateManager.container.getWidget('DIARIOFORM');
            widgetForm.dataSource.data = compromissos;
        }
    };

    this.getDataSincroniza = function() {
        return moment().subtract(30, 'days').calendar();
    };

    this.openFilterPopupDiario = function() {
        var widget = templateManager.container.getWidget('FILTRO');
        ScreenService.openPopup(widget);
        widget.isVisible = true;
        widget.activate();
    };

    this.closeFilterPopupDiario = function() {
        var widget = templateManager.container.getWidget('FILTRO');
        ScreenService.closePopup(widget);
        widget.isVisible = false;
        templateManager.container.getWidget('DIARIO').activate();
    };

    this.filtrarMobileDiario = function() {
        var promises = [];
        promises.push(Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree"));
        promises.push(Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/pedido_filial_modpgto"));
        ZHPromise.all(promises).then(function(success){
            if (success[0].length > 0 && success[1].length > 0) {
                this.dataAgevenrealizado  = success[0];
                this.pedidos  = success[1];
                var data = moment().format('DD/MM/YYYY');
                var compromissos = [];
                if (templateManager.container.getWidget('FILTRO').currentRow.DTAGEVENDREGIAO) {
                    data = templateManager.container.getWidget('FILTRO').currentRow.DTAGEVENDREGIAO;
                }
                compromissos = this.dataAgevenrealizado.filter(function(value){return value.CDVENDEDOR == this.vendedor.CDVENDEDOR && value.DTAGEVENDREGIAO == data + ' 00:00:00';}.bind(this));
                var widgetData = templateManager.container.getWidget('DIARIO');
                widgetData.dataSource.data = compromissos;
                this.closeFilterPopupDiario();
            }
        }.bind(this), function (error) {
            ScreenService.showMessage(error);
        }.bind(this));
    };

    this.enviarDadosControleVisita = function(widget) {
        Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree").then(function (success) {
            this.dataAgevenrealizado = success;
            Ped07001_ControleVisitasVendedor_Service.enviarDadosControleVisita(success).then(function (callback) {

                widget.dataSource.data = this.dataAgevenrealizado;
                var dataAgevenrea;
                var findAgevenrealizadoFunc = function(value){ return value.CDVENDEDOR == callback.dataset.agevenrealizado[i].CDVENDEDOR && value.CDPARENT == callback.dataset.agevenrealizado[i].CDPARENT && value.DTAGEVENDREGIAO == callback.dataset.agevenrealizado[i].DTAGEVENDREGIAO && value.CDCLIENTE == callback.dataset.agevenrealizado[i].CDCLIENTE;};
                callback.dataset.agevenrealizado.forEach(function(value) { value.__is_new = false;});
                for (var i = 0; i < callback.dataset.agevenrealizado.length; i++) {
                    dataAgevenrea = this.dataAgevenrealizado.find(findAgevenrealizadoFunc);
                    if (callback.dataset.agevenrealizado[i].NRSEQREALIZADO) {
                        dataAgevenrea.NRSEQREALIZADO = callback.dataset.agevenrealizado[i].NRSEQREALIZADO;
                        dataAgevenrea.__is_new = callback.dataset.agevenrealizado[i].__is_new;
                    }
                }
                //ScreenService.showMessage(mensagens.dadosEnviados);
                ScreenService.showMessage("Dados enviados com sucesso!");
                ScreenService.closePopup();
                Ped07001_ControleVisitasVendedor_Service.setData("ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree", this.dataAgevenrealizado).then(function(){
                    this.filtrarMobileDiario();
                }.bind(this),
                function() {
                    //ScreenService.showMessage(mensagens.errorEnviarDados);
                    ScreenService.showMessage("Erro ao enviar dados. Tente novamente mais tarde!");
                }.bind(this));
            }.bind(this), function() {
                //ScreenService.showMessage(mensagens.errorEnviarDados);
                ScreenService.showMessage("Erro ao enviar dados. Tente novamente mais tarde!");
            });
        }.bind(this),
        function() {
            //ScreenService.showMessage(mensagens.errorEnviarDados);
            ScreenService.showMessage("Erro ao enviar dados. Tente novamente mais tarde!");
        });
    };

    this.cancel = function(args) {
        var deferred = ZHPromise.defer();
        if (args.row.__is_new) {
            args.owner.widget.list(true);
            args.owner.widget.dataSource.data.pop();
            args.owner.widget.currentRow = {};
            deferred.resolve();
        } else if (args.owner.widget.mode === 'edit') {
            args.owner.widget.view();
            args.owner.widget.template = "widget/form-view.html";
            deferred.resolve();
            return deferred.promise;
        }
        ScreenService.goBack();
        return deferred.promise;
    };

    this.saveMobile = function(widget) {
        if (widget.currentRow.DSJUSTIFICA !== 0) {
            if (widget.currentRow.DSREALIZADO) {
                widget.currentRow.DSJUSTIFICA = 2;
            } else {
                widget.currentRow.DSJUSTIFICA = 1;
            }
        }

        var CDPRIMARY = widget.currentRow.CDPRIMARY.split("-");
        widget.currentRow.CDREGIAOPED = CDPRIMARY[0];
        widget.currentRow.CDVENDEDOR = CDPRIMARY[1].split("/")[0].replace(" ","");
        widget.currentRow.CDCLIENTE = CDPRIMARY[1].split("/")[1];
        widget.currentRow.DTREALIZADO = widget.currentRow.DTAGEVENDREGIAO;
        // widget.paramsNewCode.__new_code_pk = 'AGEVENREALIZADO'+General.getFieldValue('CDVENDEDOR', 'DIARIO')+General.getFieldValue('DTAGEVENDREGIAO', 'DIARIO');
        var teste = this.dataAgevenrealizado.find(function(value){return value.CDVENDEDOR == widget.currentRow.CDVENDEDOR && value.CDPARENT == widget.currentRow.CDPARENT && value.DTAGEVENDREGIAO == widget.currentRow.DTAGEVENDREGIAO && value.CDCLIENTE == widget.currentRow.CDCLIENTE;});
        teste.DSREALIZADO = widget.currentRow.DSREALIZADO;
        teste.DTREALIZADO = widget.currentRow.DTREALIZADO;
        if (teste.NRSEQREALIZADO) {
            teste.__is_new = false;
        } else {
            teste.__is_new = true;
        }
        teste.changed = true;
        Ped07001_ControleVisitasVendedor_Service.setData('ped_pedidos#/agevenrealizado_agendavendedor_regiaoped_tree', this.dataAgevenrealizado).then(function(){
            templateManager.container.getWidget("DIARIOTABBED").activate();
            templateManager.container.refresh();
            templateManager.container.getWidget('DIARIO').redraw();
            widget.template = "widget/form-view.html";
            widget.view();
        });
    };

    this.lancarPedido = function(widget) {
        openWindow('ped_pedidos#ped00100_lancamento_pedido').then(function(){
            var cliente = {
                "CDCLIENTE": widget.container.getWidget('DIARIO').currentRow.CDCLIENTE,
                "NMRAZSOCCLIE": widget.container.getWidget('DIARIO').currentRow.NMEXPAND,
            };
            Ped00100_lancamentoPedido_Controller.openWidgetFromDiario(true, cliente);
        });
    };

    this.setDataPedido = function() {
        Ped07001_ControleVisitasVendedor_Service.getData("ped_pedidos#/pedido_filial_modpgto").then(function(success){
            if (templateManager.container) {
                this.dataPedidos = success;
                var widgetPedido = templateManager.container.getWidget("PEDIDO");
                var widgetDiario = templateManager.container.getWidget("DIARIOFORM");
                var data = widgetDiario.currentRow.DTAGEVENDREGIAO.split(' ')[0];
                var pedido = success.filter(function(value){ return value.CDCLIENTE == widgetDiario.currentRow.CDCLIENTE && value.DTHRLANPED == data;});
                widgetPedido.dataSource.data = pedido;
            }
        }.bind(this));
    };
}


Configuration(function(ContextRegister){
    ContextRegister.register('Ped07001_ControleVisitasVendedor_Controller', Ped07001_ControleVisitasVendedor_Controller);
});